# coding: utf-8

"""
    Nomad Pilot

    This is the API descriptor for the Nomad Pilot API, responsible for shipping and logistics processing. Developed by [Samarkand Global](https://www.samarkand.global/) in partnership with [SF Express](https://www.sf-express.com/), [eSinotrans](http://air.esinotrans.com/), [sto](http://sto-express.co.uk/). Read the documentation online at [Nomad API Suite](https://api.samarkand.io/). - Install for node with `npm install nomad_pilot_cli` - Install for python with `pip install nomad-pilot-cli` - Install for Maven users `groupId, com.gitlab.samarkand-nomad; artifactId, nomad-pilot-cli`  # noqa: E501

    The version of the OpenAPI document: 1.44.1
    Contact: paul@samarkand.global
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from nomad_pilot_cli.api_client import ApiClient
from nomad_pilot_cli.exceptions import (
    ApiTypeError,
    ApiValueError
)


class LockerApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def query_locker(self, carrier, max_distance, page_no, page_size, **kwargs):  # noqa: E501
        """queryLocker  # noqa: E501

        Query the lockers of an carrier.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.query_locker(carrier, max_distance, page_no, page_size, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str carrier: String name of carrier (required)
        :param int max_distance: Max distance between lockers and the address, unit is meter (required)
        :param int page_no: Page number, between 1 and 1000 (required)
        :param int page_size: Page size, options: [1, 10, 50] (required)
        :param str province_name: Province name where customer address is
        :param str city_name: City name where customer address is
        :param str country_name: Country name where customer address is
        :param str address_detail: Customer detailed address
        :param float longitude: The longitude where customer address is
        :param float latitude: The latitude where customer address is
        :param bool query_all: Query all locker types
        :param list[str] company_list: Returns a nearby cabinet that supports any of the Courier companies in this list, options: SF
        :param str coord_type: Coordinates type, wgs84: basic, gcj02: encrypted coordinates, bd09ll: coordinates of Baidu
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: ApiResponseLockers
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.query_locker_with_http_info(carrier, max_distance, page_no, page_size, **kwargs)  # noqa: E501

    def query_locker_with_http_info(self, carrier, max_distance, page_no, page_size, **kwargs):  # noqa: E501
        """queryLocker  # noqa: E501

        Query the lockers of an carrier.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.query_locker_with_http_info(carrier, max_distance, page_no, page_size, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str carrier: String name of carrier (required)
        :param int max_distance: Max distance between lockers and the address, unit is meter (required)
        :param int page_no: Page number, between 1 and 1000 (required)
        :param int page_size: Page size, options: [1, 10, 50] (required)
        :param str province_name: Province name where customer address is
        :param str city_name: City name where customer address is
        :param str country_name: Country name where customer address is
        :param str address_detail: Customer detailed address
        :param float longitude: The longitude where customer address is
        :param float latitude: The latitude where customer address is
        :param bool query_all: Query all locker types
        :param list[str] company_list: Returns a nearby cabinet that supports any of the Courier companies in this list, options: SF
        :param str coord_type: Coordinates type, wgs84: basic, gcj02: encrypted coordinates, bd09ll: coordinates of Baidu
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(ApiResponseLockers, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['carrier', 'max_distance', 'page_no', 'page_size', 'province_name', 'city_name', 'country_name', 'address_detail', 'longitude', 'latitude', 'query_all', 'company_list', 'coord_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method query_locker" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'carrier' is set
        if self.api_client.client_side_validation and ('carrier' not in local_var_params or  # noqa: E501
                                                        local_var_params['carrier'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `carrier` when calling `query_locker`")  # noqa: E501
        # verify the required parameter 'max_distance' is set
        if self.api_client.client_side_validation and ('max_distance' not in local_var_params or  # noqa: E501
                                                        local_var_params['max_distance'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `max_distance` when calling `query_locker`")  # noqa: E501
        # verify the required parameter 'page_no' is set
        if self.api_client.client_side_validation and ('page_no' not in local_var_params or  # noqa: E501
                                                        local_var_params['page_no'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `page_no` when calling `query_locker`")  # noqa: E501
        # verify the required parameter 'page_size' is set
        if self.api_client.client_side_validation and ('page_size' not in local_var_params or  # noqa: E501
                                                        local_var_params['page_size'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `page_size` when calling `query_locker`")  # noqa: E501

        if self.api_client.client_side_validation and 'max_distance' in local_var_params and local_var_params['max_distance'] > 1000:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `max_distance` when calling `query_locker`, must be a value less than or equal to `1000`")  # noqa: E501
        if self.api_client.client_side_validation and 'max_distance' in local_var_params and local_var_params['max_distance'] < 1:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `max_distance` when calling `query_locker`, must be a value greater than or equal to `1`")  # noqa: E501
        if self.api_client.client_side_validation and 'page_no' in local_var_params and local_var_params['page_no'] > 1000:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `page_no` when calling `query_locker`, must be a value less than or equal to `1000`")  # noqa: E501
        if self.api_client.client_side_validation and 'page_no' in local_var_params and local_var_params['page_no'] < 1:  # noqa: E501
            raise ApiValueError("Invalid value for parameter `page_no` when calling `query_locker`, must be a value greater than or equal to `1`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'carrier' in local_var_params:
            path_params['carrier'] = local_var_params['carrier']  # noqa: E501

        query_params = []
        if 'province_name' in local_var_params and local_var_params['province_name'] is not None:  # noqa: E501
            query_params.append(('province_name', local_var_params['province_name']))  # noqa: E501
        if 'city_name' in local_var_params and local_var_params['city_name'] is not None:  # noqa: E501
            query_params.append(('city_name', local_var_params['city_name']))  # noqa: E501
        if 'country_name' in local_var_params and local_var_params['country_name'] is not None:  # noqa: E501
            query_params.append(('country_name', local_var_params['country_name']))  # noqa: E501
        if 'address_detail' in local_var_params and local_var_params['address_detail'] is not None:  # noqa: E501
            query_params.append(('address_detail', local_var_params['address_detail']))  # noqa: E501
        if 'longitude' in local_var_params and local_var_params['longitude'] is not None:  # noqa: E501
            query_params.append(('longitude', local_var_params['longitude']))  # noqa: E501
        if 'latitude' in local_var_params and local_var_params['latitude'] is not None:  # noqa: E501
            query_params.append(('latitude', local_var_params['latitude']))  # noqa: E501
        if 'query_all' in local_var_params and local_var_params['query_all'] is not None:  # noqa: E501
            query_params.append(('query_all', local_var_params['query_all']))  # noqa: E501
        if 'max_distance' in local_var_params and local_var_params['max_distance'] is not None:  # noqa: E501
            query_params.append(('max_distance', local_var_params['max_distance']))  # noqa: E501
        if 'company_list' in local_var_params and local_var_params['company_list'] is not None:  # noqa: E501
            query_params.append(('company_list', local_var_params['company_list']))  # noqa: E501
            collection_formats['company_list'] = 'multi'  # noqa: E501
        if 'page_no' in local_var_params and local_var_params['page_no'] is not None:  # noqa: E501
            query_params.append(('page_no', local_var_params['page_no']))  # noqa: E501
        if 'page_size' in local_var_params and local_var_params['page_size'] is not None:  # noqa: E501
            query_params.append(('page_size', local_var_params['page_size']))  # noqa: E501
        if 'coord_type' in local_var_params and local_var_params['coord_type'] is not None:  # noqa: E501
            query_params.append(('coord_type', local_var_params['coord_type']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['ca_key']  # noqa: E501

        return self.api_client.call_api(
            '/ship/lockers/{carrier}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiResponseLockers',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
